/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package generator;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 *
 * @author Lenka
 */
public class GUI extends Application {

    @Override
    public void start(Stage primaryStage) {

        Label nLabel = new Label("Počet viet: ");
        TextField pViet = new TextField();
        Label nLabel2 = new Label("Maximálna dĺžka jednej vety: ");
        TextField maxLen = new TextField();
        Label nLabel3 = new Label("Minimálna dĺžka jednej vety: (min 1) ");
        TextField minLen = new TextField();

        Button ok = new Button("Zadané hodnoty");

        ok.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                try {
                    
                    String text = pViet.getText();
                    try {
                        int test = Integer.parseInt(text);
                    } catch (Exception e) {
                        System.err.println("ERR:Zle cislo 1..");
                        Alert alert = new Alert(AlertType.ERROR);
                        alert.setContentText("Zlé 1.číslo, zadávajte prosím len KLADNÉ čísla v rozsahu do 2^31");
                        alert.showAndWait();
                    }
                    int viet = Integer.parseInt(text);
                    
                    text = minLen.getText();
                    try {
                        int test = Integer.parseInt(text);
                    } catch (Exception e) {
                        System.err.println("ERR:Zle cislo 2..");
                        Alert alert = new Alert(AlertType.ERROR);
                        alert.setContentText("Zlé 2.číslo, zadávajte prosím len KLADNÉ čísla v rozsahu do 2^31");
                        alert.showAndWait();
                    }
                    int minDlzka = Integer.parseInt(text);
                    
                    
                    
                    text = maxLen.getText();
                    try {
                        int test = Integer.parseInt(text);
                    } catch (Exception e) {
                        System.err.println("ERR:Zle cislo 3..");
                        Alert alert = new Alert(AlertType.ERROR);
                        alert.setContentText("Zlé 3.číslo, zadávajte prosím len KLADNÉ čísla v rozsahu do 2^31");
                        alert.showAndWait();
                    }
                    int maxDlzka = Integer.parseInt(text);
                    
                    
                    System.out.println(viet + " " + maxDlzka + " " + minDlzka + " ");
                    if (viet<1 || minDlzka<1 || maxDlzka<minDlzka){
                        
                        Alert alert = new Alert(AlertType.ERROR);
                        alert.setContentText("Zlé čísla, zadávajte prosím len KLADNÉ čísla v rozsahu do 2^31");
                        alert.showAndWait();
                        
                        throw new IllegalArgumentException("Nesedi logika.. Zamyslite sa nad svojimi cislami!");
                    }
                    
                    generator.vygeneruj(viet, minDlzka, maxDlzka);
                    
                    System.exit(0);
                } catch (Exception e) {
                    System.err.println("ERR:Nieco sa pokazilo, skuste este raz a zadajte vhodne cisla - INTEGER \n " + e.getMessage());
                }

            }
        });

//        Button def = new Button("Default hodnoty (100 000, 1-514)");
        Button def = new Button("Náhodné default");
        def.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                try {
                    int n = 100000;  /// 100000
                    generator.vygeneruj(n, 1, 514);   //(n, 1, 514)
                    System.exit(0);

                } catch (Exception e) {
                    System.err.println("ERR:Nieco sa pokazilo \n " + e.getMessage());
                }

            }
        });
       
        
         Button perm = new Button("Opakovania 1 písmena");
        perm.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                try {
                    int pismen = 1;
                    int pocet = 1025;
                    generator.vygenerujPermutacie(pismen, pocet);
                    System.exit(0);

                } catch (Exception e) {
                    System.err.println("ERR:Nieco sa pokazilo \n " + e.getMessage());
                }

            }
        });
        
        
        Button nulls = new Button("Nulls");
        nulls.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                try {
                    int pocet = 1025;
                    generator.vygenerujNull(pocet);
                    System.exit(0);

                } catch (Exception e) {
                    System.err.println("ERR:Nieco sa pokazilo \n " + e.getMessage());
                }

            }
        });
       
        
        VBox root = new VBox();
        
        root.getChildren().addAll(nLabel, pViet, nLabel3, minLen, nLabel2, maxLen, ok, def, perm, nulls );

        
        
        Scene scene = new Scene(root, 300, 250);
        scene.getStylesheets().add("Styles.css");
        
        primaryStage.setTitle("Generátor");
        primaryStage.setMinHeight(750);
        primaryStage.setMinWidth(500);
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }

}
