/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package generator;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;

/**
 *
 * @author Lenka
 */
class generator {

    public static String toHexString(String input) {
        return String.format("%x", new BigInteger(1, input.getBytes()));
    }

    public static String fromHexString(String hex) {
        StringBuilder str = new StringBuilder();
        for (int i = 0; i < hex.length(); i += 2) {
            str.append((char) Integer.parseInt(hex.substring(i, i + 2), 16));
        }
        return str.toString();
    }

    static void vygenerujA(int viet, int minDlzka, int maxDlzka) throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vstup.txt")));

        for (int i = 0; i < viet; i++) {
            int dlzkaVety = (int) (Math.round(Math.random() * (maxDlzka - minDlzka))) + minDlzka;
            //System.out.println("Vyslo " + dlzkaVety);
            StringBuilder veta = new StringBuilder();
            for (int j = 0; j < dlzkaVety; j++) {
                int r = (int) (Math.random() * 94);
                r = r + 32;
                //System.out.println(r);
                if (r > 126 || r < 32) {
                    System.out.println("podarilo sa nam vygenerovat neplatny znak :o ");
                    throw new IllegalArgumentException("Nesedi logika.. Zamyslite sa nad svojimi cislami!");
                }
                char c = (char) r;
                veta.append(c);
            }
            //System.out.println("Vysla veta: " + veta);
            pw.println("" + toHexString(veta.toString()) + "");
        }

        pw.close();
        System.out.println("OK");

    }

    static void vygeneruj(int viet, int minDlzka, int maxDlzka) throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vstup.txt")));

        for (int i = 0; i < viet; i++) {
            int dlzkaVety = (int) (Math.round(Math.random() * (maxDlzka - minDlzka))) + minDlzka;
            //System.out.println("Vyslo " + dlzkaVety);
            StringBuilder veta = new StringBuilder();
            for (int j = 0; j < dlzkaVety; j++) {
                int r = (int) (Math.random() * 256);

                if (r > 255 || r < 0) {
                    System.out.println("podarilo sa nam vygenerovat neplatny znak");
                    throw new IllegalArgumentException("Nesedi logika.. Zamyslite sa nad svojimi cislami!");
                }

                if (r<16){
                    veta.append("0");
                }
                veta.append(Integer.toHexString(r));
            }

            if ((veta.length() % 2) == 1) {
                System.err.println("NIECO SA POKAZILO.. Idem to trochu opravit");
                veta.insert(0, "0");
            }
            pw.println("" + veta.toString() + "");
        }

        pw.close();
        System.out.println("OK");

    }

    /*
    / Len pre pocet pismen 1 - teda pre A
     */
    static void vygenerujPermutacie(int pismen, int pocet) throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vstup.txt")));
        StringBuilder veta = new StringBuilder();
        veta.append("a");

        for (int i = 0; i < pocet; i++) {
            pw.println("" + toHexString(veta.toString()) + "");
            veta.append("a");
        }

        pw.close();
        System.out.println("OK");
    }

    static void vygenerujNull(int pocet) throws IOException {
        PrintWriter pw = new PrintWriter(new FileWriter(new File("vstup.txt")));
        StringBuilder veta = new StringBuilder();
        veta.append("00");

        for (int i = 0; i < pocet; i++) {
            pw.println("" + veta.toString() + "");
            veta.append("00");
        }

        pw.close();
        System.out.println("OK");

    }

}
