package hashovac.FNV;
      
public final class FNVHashNoIPrime {

    private static final long FNV_64_INIT = 0xcbf29ce484222325L;
    private static final long FNV_64_PRIME = 0;

    public FNVHashNoIPrime() {}

    public static long hash64(final byte[] k) {
        long rv = FNV_64_INIT;
        final int len = k.length;
        for(int i = 0; i < len; i++)       
            rv ^= k[i];
            rv *= FNV_64_PRIME;
        
        return rv;
    }

}