/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package hashovac.Pearsonn;

/**
 *
 * @author Lenka
 */
public class PearsonZlePole {
    
    static byte[] T = new byte[256];
    
    public static void inicializujPole(){
        for (int i=0;i<256;i++){
            T[i]=(byte)i;
        }
        
        for (int i=0;i<10000;i++){
            int x1 = (int) (Math.random()*256);
            int x2 = (int) (Math.random()*256);
            T[x1]=T[x2];
            T[x2]=T[x1];
        }
    }

    public static byte[] Pearson16(byte[] x) {
        int i, j;
        byte[] hh = new byte[8];

        byte h = 0;
        for (j = 0; j < 8; ++j) {
            h = T[Math.floorMod((x[0] + j), 256)];
            for (i = 1; i < x.length; ++i) {
                h = T[Math.floorMod((h ^ x[i]), 256) ];
            }
            hh[j] = h;
        }
        return hh;
    }
}
