/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package prng;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 *
 * @author Lenka
 */
public class PRNG extends Application {
    
    static int vyskaSceny = 600;
    static int sirkaSceny = 800;
    
    @Override
    public void start(Stage primaryStage) {
        
        Label lbl = new Label("Sprav výstup:");          
        Button btn0 = new Button("LCG");
        Button btn1 = new Button("Mersene Twist");
        
        Button koniec = new Button("Koniec");
        koniec.setId("Koniec");
        koniec.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                System.exit(0);
            }
        });
        
        VBox root = new VBox();
        root.getChildren().addAll(lbl, btn0, btn1, koniec);
        
        Scene scene = new Scene(root, sirkaSceny, vyskaSceny);
        scene.getStylesheets().add("Styles.css");
        
        primaryStage.setTitle("Generátor náhodných čísel");
        primaryStage.setScene(scene);
        primaryStage.setMinHeight(vyskaSceny);
        primaryStage.setMinWidth(sirkaSceny);
        primaryStage.show();
        
        sceny.nastavLCGbtn(btn0, scene, primaryStage);
        sceny.nastavMTbtn(btn1, scene, primaryStage);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
