/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package prng;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ScrollPane;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 *
 * @author Lenka
 */
class sceny {

    static void nastavLCGbtn(Button btn, Scene scene, Stage primaryStage) {
        btn.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent event) {

                Button b0 = new Button("LCG originál");
                b0.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.OrigLCG();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b1 = new Button("1. Seed 0");
                b1.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.LCG1seed0();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b2 = new Button("2. Seed 1");
                b2.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.LCG2seed1();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b3 = new Button("2. Maximum je párne");
                b3.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.LCG3parneMax();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b4 = new Button("2. Maximum nepárne, ale zložené");
                b4.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.LCG4MaxNepAleZlozene();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b5 = new Button("2. Konštanta je menšia");
                b5.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.LCG5mensieA();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b6 = new Button("1. Neinicializ. konštanta");
                b6.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.LCG6neiA();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b7 = new Button("2. Všetky konštanty trochu upravené");
                b7.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.LCG7VsetkyKonstantyZmenene();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });

                Button back = new Button("Naspäť");
                back.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        primaryStage.setScene(scene);
                    }

                });

                VBox vb = new VBox();
                ScrollPane scroll = new ScrollPane(vb);
                vb.setSpacing(20);
                vb.setAlignment(Pos.CENTER);
                vb.getChildren().addAll(b0,b1,b6,b2,b3,b4,b5,b7, back);
                Scene sc = new Scene(scroll, PRNG.sirkaSceny, PRNG.vyskaSceny);
                sc.getStylesheets().add("Styles.css");
                primaryStage.setScene(sc);
            }
        });
    }

    static void nastavMTbtn(Button btn, Scene scene, Stage primaryStage) {
        btn.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent event) {

                Button b0 = new Button("Mersene Twist originál");
                b0.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.OrigMT();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b1 = new Button("2. Iné konštnanty");
                b1.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.MT1IK();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b2 = new Button("1. Neinic. konštanty");
                b2.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.MT2NeiK();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
                Button b3 = new Button("2. Pozmenený seed init");
                b3.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.MT3Nieco();
                        } catch (IOException ex) {
                            Logger.getLogger(sceny.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });

                Button back = new Button("Naspäť");
                back.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        primaryStage.setScene(scene);
                    }

                });

                VBox vb = new VBox();
                ScrollPane scroll = new ScrollPane(vb);
                vb.setSpacing(20);
                vb.setAlignment(Pos.CENTER);
                vb.getChildren().addAll(b0,b2,b1,b3, back);
                Scene sc = new Scene(scroll, PRNG.sirkaSceny, PRNG.vyskaSceny);
                sc.getStylesheets().add("Styles.css");
                primaryStage.setScene(sc);
            }
        });
    }
    
}
