/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package zobrazovac_vlastnosti;

import com.sun.javafx.scene.control.skin.DatePickerContent;
import java.awt.event.MouseEvent;
import java.math.BigInteger;
import java.util.Comparator;
import java.util.Vector;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.chart.BarChart;
import javafx.scene.chart.CategoryAxis;
import javafx.scene.chart.NumberAxis;
import javafx.scene.chart.ScatterChart;
import javafx.scene.chart.XYChart;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.control.Tooltip;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.image.PixelWriter;
import javafx.scene.image.WritableImage;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.Pane;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.TilePane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.StageStyle;

/**
 *
 * @author Lenka
 */
class vlastnost {

    static void modulo(int x, Vector<String> vec) {
        //
        int[] hodnoty = new int[x];
        for (int i = 0; i < x; i++) {
            hodnoty[i] = 0;
        }
        //
        BigInteger x1 = new BigInteger(Integer.toString(x));

        for (int i = 0; i < vec.size(); i++) {
            BigInteger ba = new BigInteger(vec.get(i), 16);
            BigInteger mojahodnota = ba.mod(x1);
            String s = mojahodnota.toString();
            Integer z = Integer.parseInt(s);
//            System.out.println(z);

            hodnoty[z]++;
        }

//        System.out.println("IDEEEEEEEEEEEEEEEEEM");
//        for (int i=0;i<x;i++){
//            System.out.println(hodnoty[i]);
//        }
        Stage primaryStage = new Stage();

        primaryStage.setTitle(Zobrazovac_vlastnosti.nazov);
//        primaryStage.setFullScreen(true);

        CategoryAxis xAxis = new CategoryAxis();
        xAxis.setLabel("modulá");

        NumberAxis yAxis = new NumberAxis();
        yAxis.setLabel("počet");

        BarChart barChart = new BarChart(xAxis, yAxis);

        XYChart.Series dataSeries1 = new XYChart.Series();
        dataSeries1.setName(Zobrazovac_vlastnosti.nazov + " modulo " + x);
        for (int i = 0; i < x; i++) {
            dataSeries1.getData().add(new XYChart.Data(Integer.toString(i), hodnoty[i]));
        }

        barChart.getData().add(dataSeries1);

        VBox vbox = new VBox(barChart);

        Scene scene = new Scene(vbox, 400, 200);

        primaryStage.setScene(scene);
        primaryStage.setHeight(300);
        primaryStage.setWidth(1200);

        primaryStage.show();

    }

    static void pocetnost(Vector<Vector<Integer>> vec) {
        Stage stage = new Stage();
        stage.setTitle(Zobrazovac_vlastnosti.nazov);
        int UplnyMin = Integer.MAX_VALUE;
        int UplnyMax = 0;

        XYChart.Series series1 = new XYChart.Series();
        series1.setName("Min");
        XYChart.Series series2 = new XYChart.Series();
        series2.setName("Max");

        Button series3 = new Button();

        //XYChart.Series series3 = new XYChart.Series();
        //series3.setName("Ostatne");
        for (int i = 0; i < vec.size(); i++) {
            int max = 0;
            int min = Integer.MAX_VALUE;
            int ktoremin = -1;
            int ktoremax = -1;

            for (int j = 0; j < vec.get(i).size(); j++) {
                if (vec.get(i).get(j) > max) {
                    max = vec.get(i).get(j);
                    ktoremax = j;
                }
                if (vec.get(i).get(j) < min) {
                    min = vec.get(i).get(j);
                    ktoremin = j;
                }
//                series3.getData().add(new XYChart.Data(i, vec.get(i).get(j)));
            }
            //teraz mam ktorych je najmenej a ktorych je najviac aj ktory znak to je

            if (UplnyMax <= max) {
                UplnyMax = max;
            }
            if (UplnyMin >= min) {
                UplnyMin = min;
            }

            series1.getData().add(new XYChart.Data(i, min));
            series2.getData().add(new XYChart.Data(i, max));

        }

        final NumberAxis xAxis = new NumberAxis(-1, vec.size(), 1);
        final NumberAxis yAxis = new NumberAxis(UplnyMin-10, UplnyMax+10, 1);
        final ScatterChart<Number, Number> sc = new ScatterChart<Number, Number>(xAxis, yAxis);
        yAxis.setLabel("Početnosť (Priemerná = " + (Zobrazovac_vlastnosti.vec.size()) / (vec.get(0).size()) + ")");
        xAxis.setLabel("Poradie pol-bajtu");
        //sc.setTitle("Početnosť");

        Button detail = new Button("Zobraz detailne...");

        sc.getData().addAll(series1, series2);
        VBox vbox = new VBox(sc);
        vbox.setStyle("-fx-alignment: TOP_CENTER;");
        
        
//        vbox.setStyle("-fx-padding: 10;" + 
//                      "-fx-border-style: solid inside;" + 
//                      "-fx-border-width: 2;" +
//                      "-fx-border-insets: 5;" + 
//                      "-fx-border-radius: 5;" + 
//                      "-fx-alignment: TOP_CENTER;" +
//                      "-fx-border-color: blue;");
        
        vbox.getChildren().addAll(detail);
        Scene scene = new Scene(vbox, 1000, 450);
        scene.getStylesheets().add("Styles-jemne.css");
        stage.setScene(scene);
        stage.show();

        detail.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent event) {
                Stage dialog = new Stage();
                dialog.initStyle(StageStyle.UTILITY);
                dialog.initModality(Modality.APPLICATION_MODAL);
                dialog.setMinWidth(1000);
                TilePane pan = new TilePane();
                pan.setMinSize(250, 250);
                
                Scene sc3 = new Scene(pan);
                sc3.getStylesheets().add("Styles.css");
                TextField nText = new TextField();
                Label nLabel = new Label("Zadajte číslo pobajtu pre detailnejšie zobrazenie (max. " + (vec.size() - 1) + "):");
                Button ok = new Button("OK");

                ok.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            int poradie = Integer.parseInt(nText.getText());
                            if (poradie >= 0 && poradie < vec.size()) {
                                dialog.close();
                                vlastnost.pocetnostDetailne(vec.get(poradie), poradie);

                            }

                        } catch (Exception e) {
                            System.err.println("ERR:Zlé číslo");
                        }

                    }
                });
                pan.setPrefColumns(1);
                pan.getChildren().addAll(nLabel, nText, ok);
                dialog.setScene(sc3);
                dialog.showAndWait();
            }

        });

    }

    private static void pocetnostDetailne(Vector<Integer> jeden, int ktory) {
        int zaznamov = 0;
        Stage primaryStage = new Stage();

        primaryStage.setTitle("Pre polbajt v poradí " + ktory);

        CategoryAxis xAxis = new CategoryAxis();
        xAxis.setLabel("čísla");

        NumberAxis yAxis = new NumberAxis();
        yAxis.setLabel("početnosť");

        BarChart barChart = new BarChart(xAxis, yAxis);

        XYChart.Series dataSeries1 = new XYChart.Series();

        for (int i = 0; i < jeden.size(); i++) {
            dataSeries1.getData().add(new XYChart.Data(Integer.toHexString(i).toUpperCase(), jeden.get(i)));
            zaznamov = zaznamov + jeden.get(i);

        }

        dataSeries1.setName("Pre polbajt v poradí " + ktory + " pre celkový počet vstupov " + zaznamov);
        barChart.getData().add(dataSeries1);

        VBox vbox = new VBox(barChart);

        Scene scene = new Scene(vbox, 400, 200);

        primaryStage.setScene(scene);
        primaryStage.setHeight(300);
        primaryStage.setWidth(1200);

        primaryStage.show();
    }

    static void heatmapa(Vector<String> vstup, Vector<String> vec) {

        BorderPane root = new BorderPane();
        
        BorderPane gombiky = new BorderPane();
        
        vlastnost.zobrazHeatmapu(0, 0, root, vstup, vec);
        
        
        TextField nText = new TextField();
        Label nLabel = new Label("Vstupný polbajt (max:" + (maxvstup-1) + ")");
        TextField nText1 = new TextField();
        Label nLabel1 = new Label("Výstupný polbajt (max:" + (maxvystup-1) + ")");
        Button ok = new Button("OK");

        HBox left = new HBox(nLabel,nText);
        HBox right = new HBox(nLabel1,nText1);
        StackPane dole = new StackPane(ok);
        left.setStyle("-fx-background-color: #8595E8; -fx-padding: 5; -fx-alignment: CENTER; -fx-spacing: 0; ");
        right.setStyle("-fx-background-color: #8595E8; -fx-padding: 5; -fx-alignment: CENTER; -fx-spacing: 0; ");
        gombiky.setBottom(dole);
        gombiky.setLeft(left);
        gombiky.setRight(right);
        gombiky.setStyle(" -fx-padding: 5; -fx-alignment: CENTER; -fx-spacing: 0;-fx-border-color: #3B51C5; -fx-border-width: 5px;");
        //gombiky.getChildren().addAll(nLabel, nText, nLabel1, nText1);

        StackPane vrchnyNazov = new StackPane();
        Label nazov = new Label(Zobrazovac_vlastnosti.nazov);
        vrchnyNazov.getChildren().add(nazov);
        
        root.setTop(vrchnyNazov);
        root.setBottom(gombiky);

        Stage st = new Stage();
        Scene scene = new Scene(root, 300, 500);
        scene.getStylesheets().add("StyleHeat.css");
        st.setTitle("" + Zobrazovac_vlastnosti.nazov);
        st.setScene(scene);
        st.setHeight(800);
        st.setWidth(1000);
        st.show();
        
        //info message
        BorderPane expContent = new BorderPane();
        VBox texty = new VBox();
        
        
        Label hlavneInfo = new Label("Heatmapa zobrazuje vplyv zvolených 4 bitov zo vstupu na zvolené 4 bity výstupu\n");
        
        Label infoVystup = new Label ("<----------------------------------------------> \n   0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F \n  V tomto smere sú Výstupné \" polbajty \" od 0 po F, \n teda zahašované \n\n");
        //infoVystup.setStyle("-fx-border-color: black; -fx-border-width: 1px;");
        Label infoVstup = new Label ("^\n I  0      V tomto smere sú vstupné polbajty,\n I  1      teda polbajty začiatočných vygenerovaných viet\n I  .\n I  .\n I  F \nV \n\n");
        //infoVstup.setStyle("-fx-border-color: black; -fx-border-width: 1px;");
        
        Label dalsieInfo = new Label("Farebná škála je od modrej cez zelenú po červenú, zelená je priemer.\nAk je celý jeden riadok modrý, znamená to, že k tomu príslušné \n vstupné hexadecimálne číslo na tomto polbajte neexistovalo.\n Farebná škála: (Naľavo=0, Stred=priemer, Vpravo=všetky)");
        
        texty.getChildren().addAll(hlavneInfo,infoVystup,infoVstup, dalsieInfo);
        expContent.setTop(texty);
        
        
        WritableImage image = new WritableImage(400, 100);
        PixelWriter pixelWriter = image.getPixelWriter();
        
            for (int x=0; x<300; x++) {
                double value = MIN + (MAX - MIN) * x /300;
                Color color = getColorForValue(value);
                for (int y=0; y<30; y++) {
                    pixelWriter.setColor(x, y, color);
                }
            }
        ImageView imageView = new ImageView(image);
        StackPane stack = new StackPane(imageView);
        expContent.setBottom(stack);
        
        
        Alert alert = new Alert(Alert.AlertType.INFORMATION);
        alert.setHeaderText(null);
        alert.setTitle("Info");
        alert.setContentText("");
        alert.getDialogPane().setContent(expContent);
        
        alert.showAndWait();

        
        
        ok.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                try {
                    int vstupB = Integer.parseInt(nText.getText());
                    int vystupB = Integer.parseInt(nText1.getText());
                    if (vstupB >= 0 && vystupB >= 0 && vstupB < maxvstup && vystupB < maxvystup) {
                        vlastnost.zobrazHeatmapu(vstupB, vystupB, root, vstup, vec);
                    }
                    else {
                        /////TODO ERROR ZE ZLE CISLA
                    }

                } catch (Exception e) {
                    System.err.println("ERR:Zlé číslo " + e.getMessage());
                }

            }
        });

//        BorderPane b = new BorderPane();
//        VBox vb1 = new VBox();
//        VBox vb2 = new VBox();
//        VBox vb3 = new VBox();
//        
//        Button b1 = new Button("ASD");
//        Button b2 = new Button("VVV");
//        Button b3 = new Button("lololo");
//        Button b4 = new Button("QQQQqqqq");
//        
//        vb1.getChildren().addAll(b1);
//        vb2.getChildren().addAll(b3);
//        vb3.getChildren().addAll(b2);
//        
//        b.setTop(vb1);
//        b.setBottom(vb2);
//        
//        Stage st = new Stage();
//        Scene scene = new Scene(b, 400, 200);
//
//        st.setScene(scene);
//        st.setHeight(300);
//        st.setWidth(1200);
//        st.show();
//        
//        b3.setOnAction(new EventHandler<ActionEvent>() {
//
//            @Override
//            public void handle(ActionEvent event) {
//                b.setTop(vb3);
//            }
//            
//        });
    }

    //////////PREMENNE PRE HEATMAPU
    private final static double MIN = 0;
    private final static double MAX = 100;
    private final static double BLUE_HUE = Color.BLUE.getHue();
    private final static double RED_HUE = Color.RED.getHue();

    /////
    static int maxvstup = -1;
    static int maxvystup = -1;

    private static void zobrazHeatmapu(int vstupB, int vystupB, BorderPane root, Vector<String> vstup, Vector<String> vystup) {

// pre vstpup a vystup zaroven prejstt cely vektor a vybrat chcene bajty
//pocitat kolko bolo tej dlzkyyy!!!! nemusia byt vsetky
        int pocetVsetkych = vstup.size();
        int[][] tabulka = new int[16][16];
        for (int i = 0; i < tabulka.length; i++) {
            for (int j = 0; j < tabulka[i].length; j++) {
                tabulka[i][j] = 0;
            }
        }

        if (vystup.size() != vstup.size()) {
            System.out.println("WTF ERRORR!!!! VSTUP A VÝSTUP MÁ ROZDIELNY POČET STRINGOV.. MOŽNO STE ZABUDLI DAŤ DO VÝSTUPU AKO PRVÝ RIADOK NÁZOV ALGORITMU?"); //TODO error message?
        } else {
            ///vyplnim zo vstupu hodnoty do tabulky
            for (int i = 0; i < vstup.size() ; i++) { //vstup.size()
                try{
                if (vstup.get(i).length() <= vstupB || vystup.get(i).length() <= vystupB) {
                    //System.out.println("ODPOCIITAVAM LEBO NEBOLO ");
                    pocetVsetkych--;
                } else {
                    if (maxvstup < vstup.get(i).length()) {
                        maxvstup = vstup.get(i).length();
                    }
                    if (maxvystup < vystup.get(i).length()) {
                        maxvystup = vystup.get(i).length();
                    }
                    int x = Character.getNumericValue(vystup.get(i).charAt(vystupB));
                    int y = Character.getNumericValue(vstup.get(i).charAt(vstupB));
                    tabulka[x][y] = tabulka[x][y] + 1;
                }
                } catch (Exception e){
                    System.err.println(" ehmmm.... " + i + " " + vstup.get(i) + " " + vystup.get(i) + " ");
                }
            }

            ///pocitam a tvorim heatmapu 
            //sirka, vyska
            int sirkaJednehoPixela = 25;
            int vyskaJednehoPixela = 25;
            
            WritableImage image = new WritableImage(sirkaJednehoPixela*16, vyskaJednehoPixela*16);
            PixelWriter pixelWriter = image.getPixelWriter();
            
            
           ///////////////////TODO tu dokoncit prezeranie spravnosti...
           //////////////////TODO zobrazovat aj defaultnu farbu a defaultnu velkost jedneho stvorceka

//            for (int i = 0; i < tabulka.length; i++) {
//                for (int j = 0; j < tabulka[i].length; j++) {
//                    System.out.print(tabulka[i][j] + " ");
//                }
//                System.out.println("");
//            }
            double priemer = (double) pocetVsetkych / (16 * 16);
            
            System.out.println("Priemer  " + priemer);

            int x = 0;
            int y = 0;
            for (int i = 0; i < tabulka.length; i++) {

                for (int j = 0; j < tabulka[i].length; j++) {
                    double percenta = 0;
                    if (tabulka[i][j] == priemer) {
                        //System.out.print("pre " + i + "  " + j + "  mame " + priemer + " " + tabulka[i][j]);
                        percenta = 0.5;
                    } else if (tabulka[i][j] < priemer) {
                        //System.out.print("pre " + i + "  " + j + "  mame " + priemer + " " + tabulka[i][j]);
                        percenta = vypocitajPercenta(0, priemer, tabulka[i][j],true);
                    } else {
                        //System.out.print("pre " + i + "  " + j + "  mame " + priemer + " " + tabulka[i][j]);
                        percenta = vypocitajPercenta(priemer, pocetVsetkych, tabulka[i][j],false);

                    }

                    //System.out.println(" " + percenta);
                    double value = (MIN + (MAX - MIN)) * (percenta);
//                    double value = Math.random()*100;
                    //System.out.println(" " + value);
                    Color color = getColorForValue(value);
                    for (int q = 0; q < sirkaJednehoPixela; q++) {
                        for (int w = 0; w < vyskaJednehoPixela; w++) {
                            pixelWriter.setColor(sirkaJednehoPixela * x + q, vyskaJednehoPixela * y + w, color);
                        }
                    }
//                    for (int y = 0; y < vyskaJednehoPixela; y++) {
//                        for (int f = 0; f < sirkaJednehoPixela; f++) {
//                            pixelWriter.setColor(x + f, y, color);
//                        }
//                    }

                    y++;
                }

                x++;
                y = 0;
            }
            ImageView imageView = new ImageView(image);
            StackPane stack = new StackPane(imageView);
            VBox info = new VBox();
            Label ktore = new Label("Polbajty v poradí: " + vstupB + ". / " + vystupB + ". (vstupný / vystupný)");
            Label vsetkych = new Label("Záznamov tejto heatmapy: " + pocetVsetkych);
            Label pocetTychtoVstupov = new Label("Priemer na jednom políčku: " + priemer);
            info.getChildren().addAll(ktore, vsetkych, pocetTychtoVstupov);
            
            BorderPane zaklad = new BorderPane();
            zaklad.setBottom(info);
            info.setStyle("-fx-alignment: CENTER; ");
            
            zaklad.setTop(stack);
            
            root.setCenter(zaklad);
            
        }

        // ZOBRAZIT NIEKDE DO ROZKU "Idelanu zelenu" mozno aj skalu 0/50/100
//
    }

    static private Color getColorForValue(double value) {
//        if(value!=0){
//        System.out.println(" farbaaaaaa value " + value);
//                }
        if (value < MIN || value > MAX) {
            return Color.BLACK;
        }
        double hue = BLUE_HUE + (RED_HUE - BLUE_HUE) * (value - MIN) / (MAX - MIN);
        return Color.hsb(hue, 1.0, 1.0);
    }

    private static double vypocitajPercenta(double od, double po, int hodnota, boolean prvy) {
        int pridaj = 50;
        if (prvy) {//prva polovica
            pridaj = 0;
        }
        return (((50.0 / (po - od)) * (hodnota - od)) + pridaj) / 100.0;

    }

}
