/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package hashovac;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ScrollPane;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

/**
 *
 * @author Lenka
 */
public class Hashovac extends Application {
    
    static int vyskaSceny = 600;
    static int sirkaSceny = 800;
    
    @Override
    public void start(Stage primaryStage) {
        
        Label lbl = new Label("Sprav výstup:");          
        Button btn0 = new Button("MD5");
        Button btn1 = new Button("SHA-1");
        Button btn2 = new Button("RC4");
        Button btn3 = new Button("MurmurHash");
        Button btn4 = new Button("FNV");
        Button btn5 = new Button("Pearson hash");
        Button btn6 = new Button("Developers Button");
        
        Button koniec = new Button("Koniec");
        koniec.setId("Koniec");
        koniec.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                System.exit(0);
            }
        });
        
        
        VBox root = new VBox();
        ScrollPane scroll = new ScrollPane(root);
        root.getChildren().addAll(lbl, btn0, btn1, btn2, btn3, btn4, btn5, koniec);
        //root.getChildren().addAll(lbl, btn0, btn1, btn2, koniec);
        root.setSpacing(20);
        root.setAlignment(Pos.CENTER);
        Scene scene = new Scene(scroll, sirkaSceny, vyskaSceny);
        scene.getStylesheets().add("Styles.css");
        
        primaryStage.setTitle("Hashovač");
        primaryStage.setScene(scene);
        primaryStage.setMinHeight(vyskaSceny);
        primaryStage.setMinWidth(sirkaSceny);
        primaryStage.show();
        
        sceny.nastavMD5(btn0, scene, primaryStage);
        sceny.nastavSHA1(btn1, scene, primaryStage);
        sceny.nastavRC4(btn2, scene, primaryStage);
        sceny.nastavMurmur(btn3, scene, primaryStage);
        sceny.nastavFNV(btn4, scene, primaryStage);
        sceny.nastavPearson(btn5, scene, primaryStage);
        
        
                btn6.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            Funkcie.OrigMD5();
                        } catch (IOException ex) {
                            Logger.getLogger(Hashovac.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }

                });
        
        
        
        
        
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
