package hashovac.Pearsonn;

public class PearsonNP {

    public static byte[] Pearson16(byte[] x) {
        int i, j;
        byte[] hh = new byte[8];
        byte[] T = new byte[256];

        byte h = 0;
        for (j = 0; j < 8; ++j) {
            h = T[Math.floorMod((x[0] + j), 256)];
            for (i = 1; i < x.length; ++i) {
                h = T[Math.floorMod((h ^ x[i]), 256) ];
            }
            hh[j] = h;
        }
        return hh;
    }
}
