/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package prng_vlastnosti;

import java.io.IOException;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.TilePane;
import javafx.scene.layout.VBox;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.StageStyle;

/**
 *
 * @author Lenka
 */
public class PRNG_vlastnosti extends Application {
   
    static public String nazov;
    static Vector<Integer> vstup = new Vector<Integer>();

    @Override
    public void start(Stage primaryStage) {
        
        Button btn = new Button();
        btn.setText("Zobraz modulo");
        btn.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent event) {

                Stage dialog = new Stage();
                dialog.initStyle(StageStyle.UTILITY);
                dialog.initModality(Modality.APPLICATION_MODAL);
                TilePane pan = new TilePane();
                pan.setMinSize(250, 250);
                Scene sc3 = new Scene(pan);
                sc3.getStylesheets().add("Styles.css");
                TextField nText = new TextField();
                Label nLabel = new Label("Zadajte číslo modula(1-4999) : ");
                Button ok = new Button("OK");

                ok.setOnAction(new EventHandler<ActionEvent>() {
                    @Override
                    public void handle(ActionEvent event) {
                        try {
                            int modulo = Integer.parseInt(nText.getText());
                            if (modulo > 0 && modulo < 5000) {
                                dialog.close();
                                vlastnost.modulo(modulo, vstup);
                            }
                            

                        } catch (Exception e) {
                            System.err.println("ERR:Zlé číslo");
                        }

                    }
                });
                pan.setPrefColumns(2);
                pan.getChildren().addAll(nLabel, nText, ok);
                dialog.setScene(sc3);
                dialog.showAndWait();

                //System.out.println(vec.size());

            }
        });

        Button poc = new Button("Zobrazenie v čase (Odporúčané\npre max. 1000 vstupov)");
        poc.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent event) {
                vlastnost.linear(vstup);
            }
            
        });
            
        try {
            Nacitaj.nacitaj();
            //System.out.println(vstup.size() + " " + vec.size());
        } catch (IOException ex) {
            Logger.getLogger(PRNG_vlastnosti.class.getName()).log(Level.SEVERE, null, ex);
        }

        //buttony na vlastnosti
        VBox root = new VBox();
        root.getChildren().addAll(btn,poc);

        Scene scene = new Scene(root, 300, 250);
        scene.getStylesheets().add("Styles.css");

        primaryStage.setTitle("Vlastnosti PRNG");
        primaryStage.setScene(scene);
        primaryStage.setMinWidth(600);
        primaryStage.setMinHeight(400);
        primaryStage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
}
